unit uMySQL;

interface

uses
  SysUtils, DateUtils, StrUtils, Classes, Windows, ShellApi;

type
  TMySQL = class
  public
    class function Backup(banco : string; user : string; pass : string; BKPPath : string; MySQLDumpPath : string) : Boolean;
    class function Restore(user : string; pass : string; BKPPath : string; MySQLPath : string) : Boolean;
  end;

implementation

{ TMySQL }

class function TMySQL.Backup(banco, user, pass, BKPPath, MySQLDumpPath: string): Boolean;
var
  cmd : string;
begin
  Result := False;
  try
    cmd := '/c "'+ MySQLDumpPath +'" -B -c --single-transaction '+
           '--default-character-set=utf8 '+ banco +' -u '+ user +' --password='+ pass +
           ' > C:\Backup_'+ banco +'_'+ FormatDateTime('yyyymmdd', Date) +'.sql';

    ShellExecute(hInstance, 'open', 'cmd.exe', Pchar(cmd), nil, SW_HIDE);

    Result := True;
  except
    on e : Exception do begin
      MessageBox(0, PChar(e.Message), 'Erro', MB_ICONSTOP or MB_OK);
      Exit;
    end;
  end;
end;

class function TMySQL.Restore(user, pass, BKPPath, MySQLPath: string): Boolean;
var
  cmd : string;
begin
  Result := False;
  try
    cmd := '/c "'+ MySQLPath +'"  -u '+ user +' --password='+ pass +' < '+ BKPPath;

    ShellExecute(hInstance, 'open', 'cmd.exe', Pchar(cmd), nil, SW_HIDE);

    Result := True;
  except
    on e : Exception do begin
      MessageBox(0, PChar(e.Message), 'Erro', MB_ICONSTOP or MB_OK);
      Exit;
    end;
  end;
end;

end.
