unit FMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, uMySQL, StdCtrls, Buttons, WideStrings, DBXMySql, DB, SqlExpr,
  DBClient, SimpleDS, Grids, DBGrids, ExtCtrls, DBCtrls, FileCtrl;

type
  TfrmMain = class(TForm)
    grdAgenda: TDBGrid;
    SDSAgenda: TSimpleDataSet;
    SDSAgendaID: TIntegerField;
    SDSAgendaNOME: TStringField;
    SDSAgendaTELEFONE: TStringField;
    SDSAgendaEMAIL: TStringField;
    SDSAgendaNASCIMENTO: TDateField;
    DSAgenda: TDataSource;
    dbnAgenda: TDBNavigator;
    pnlMain: TPanel;
    Label1: TLabel;
    edtBanco: TEdit;
    Label2: TLabel;
    edtUser: TEdit;
    Label3: TLabel;
    edtSenha: TEdit;
    Label4: TLabel;
    dirBKP: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    btnBackup: TBitBtn;
    btnRestore: TBitBtn;
    opdMain: TOpenDialog;
    procedure SDSAgendaAfterDelete(DataSet: TDataSet);
    procedure SDSAgendaAfterPost(DataSet: TDataSet);
    procedure btnBackupClick(Sender: TObject);
    procedure btnRestoreClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    oSQLConnection : TSQLConnection;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

procedure TfrmMain.btnBackupClick(Sender: TObject);
var
  mysqlDump : String;
begin
  mysqlDump := ExtractFilePath(Application.ExeName) + 'mysqldump.exe';

  if (TMySQL.Backup(edtBanco.Text, edtUser.Text, edtSenha.Text, dirBKP.Directory, mysqlDump)) then begin
    MessageBox(0, 'Backup realizado com sucesso!', 'Informao', MB_ICONINFORMATION or MB_OK);
    Exit;
  end;
end;

procedure TfrmMain.btnRestoreClick(Sender: TObject);
var
  mysql : String;
begin
  mysql := ExtractFilePath(Application.ExeName) + 'mysql.exe';

  if (opdMain.Execute) then begin
    TMySQL.Restore(edtUser.Text, edtSenha.Text, opdMain.FileName, mysql);
    SDSAgenda.Refresh;
  end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  oSQLConnection := TSQLConnection.Create(nil);

  oSQLConnection.Close;
  oSQLConnection.ConnectionName := 'ACTIVEAGENDA';
  oSQLConnection.DriverName := 'MYSQL';
  oSQLConnection.GetDriverFunc := 'getSQLDriverMYSQL';
  oSQLConnection.KeepConnection := True;
  oSQLConnection.LibraryName := 'dbxmys.dll';
  oSQLConnection.LoginPrompt := False;
  oSQLConnection.VendorLib := 'libmysql.dll';

  oSQLConnection.Params.Add('drivername=MYSQL');
  oSQLConnection.Params.Add('blobsize=-1');
  oSQLConnection.Params.Add('database=active');
  oSQLConnection.Params.Add('hostname=127.0.0.1');
  oSQLConnection.Params.Add('localecode=0000');
  oSQLConnection.Params.Add('user_name=root');
  oSQLConnection.Params.Add('password=root');
  oSQLConnection.Params.Add('compressed=False');
  oSQLConnection.Params.Add('encrypted=False');
  oSQLConnection.Params.Add('ConnectionString=drivername=MYSQL,blobsize=-1,database=active,hostname=127.0.0.1,localecode=0000,user_name=root,password=root,compressed=False,encrypted=False');

  oSQLConnection.Open;

  SDSAgenda.Close;
  SDSAgenda.Connection := oSQLConnection;
  SDSAgenda.Open;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  oSQLConnection.Destroy;
end;

procedure TfrmMain.SDSAgendaAfterDelete(DataSet: TDataSet);
begin
  SDSAgenda.ApplyUpdates(0);
end;

procedure TfrmMain.SDSAgendaAfterPost(DataSet: TDataSet);
begin
  SDSAgenda.ApplyUpdates(0);
end;

end.
